#!/bin/bash
# {{ ansible_managed }}
#
# Create statistics for the current state of metadata in the index and store the statistics in elasticsearch
#

ELASTICSEARCH_URL=http://{{ elasticsearch_host }}:{{ elasticsearch_port }}
METADATA_INDEX_NAME={{ elasticsearch_metadata_index_internal_alias_name }}
CURRENT_DATE=$(date +"%Y-%m-%d")
DATA_FIELDS="{{ search_index_statistics_fields | join(' ') }}"

date +"*** %Y-%m-%d %H:%M:%S create statistics from $METADATA_INDEX_NAME"

# START Migrate old index
STATS_INDEX_STATUS=$(curl --silent --write-out '%{http_code}' --output /dev/null --netrc-file ~/conf/search_index_elastic_access "${ELASTICSEARCH_URL}/{{ elasticsearch_metadata_index_name_prefix }}statistics")
if [[ "$STATS_INDEX_STATUS" == "200" ]]; then
  date +"*** %Y-%m-%d %H:%M:%S {{ elasticsearch_metadata_index_name_prefix }}statistics exists"
  EXISTING_STATS_ALIAS=$(curl -s --netrc-file {{ base_dir }}/conf/search_index_elastic_access "${ELASTICSEARCH_URL}/_cat/aliases/{{ elasticsearch_metadata_index_name_prefix }}statistics")
  if [ -z "$EXISTING_STATS_ALIAS" ]; then
    date +"*** %Y-%m-%d %H:%M:%S migrate old index {{ elasticsearch_metadata_index_name_prefix }}statistics"
    curl --netrc-file {{ base_dir }}/conf/search_index_elastic_access -X POST --header 'Content-Type: application/json' --header 'Accept: application/json' -d '{"source": {"index": "{{ elasticsearch_metadata_index_name_prefix }}statistics"}, "dest": {"index": "{{ elasticsearch_metadata_index_name_prefix }}statistics_old"}}' "${ELASTICSEARCH_URL}/_reindex"
    curl --netrc-file {{ base_dir }}/conf/search_index_elastic_access -X DELETE "${ELASTICSEARCH_URL}/{{ elasticsearch_metadata_index_name_prefix }}statistics"
    curl --netrc-file {{ base_dir }}/conf/search_index_elastic_access -X POST --header 'Content-Type: application/json' "${ELASTICSEARCH_URL}/_aliases" -d '{"actions": [{"add": {"index": "{{ elasticsearch_metadata_index_name_prefix }}statistics_old", "alias": "{{ elasticsearch_metadata_index_name_prefix }}statistics"}}]}'
  fi
fi
# END Migrate old index

date +"*** %Y-%m-%d %H:%M:%S init template"
# "copy_to": "provider" to support old, deprecated field
read -r -d '' TEMPLATE << EOC
{
  "index_patterns": ["{{ elasticsearch_metadata_index_name_prefix }}statistics_*"],
  "template": {
    "aliases": { "{{ elasticsearch_metadata_index_name_prefix }}statistics": {} },
    "mappings" : {
      "properties": {
        "stats_for": {
          "type": "text",
          "fields": {
            "keyword": {
              "type": "keyword"
            }
          },
          "copy_to": "provider"
        }
      }
    }
  }
}
EOC
curl -s --netrc-file {{ base_dir }}/conf/search_index_elastic_access -X PUT --header 'Content-Type: application/json' --header 'Accept: application/json' -d "$TEMPLATE" "${ELASTICSEARCH_URL}/_index_template/{{ elasticsearch_metadata_index_name_prefix }}statistics"

createStatistics() {
  STATISTICS="{\"date\":\"${CURRENT_DATE}\"}"
  if [ -z "$1" ]; then
    date +"*** %Y-%m-%d %H:%M:%S determine counts"
    COUNT_TOTAL_QUERY=
    COUNT_FIELD_BASE_QUERY="?q="
  else
{% if search_index_statistics_aggregation_field | default('', true) | length > 0 %}
    date +"*** %Y-%m-%d %H:%M:%S determine counts for $1"
    STATISTICS=$(echo $STATISTICS | jq ".stats_for = \"$1\"")
    COUNT_TOTAL_QUERY="?q={{ search_index_statistics_aggregation_field }}:\"$1\""
    COUNT_FIELD_BASE_QUERY="?q={{ search_index_statistics_aggregation_field }}:\"$1\" AND "
{% endif %}
  fi
  TOTAL=$(curl -s --netrc-file {{ base_dir }}/conf/search_index_elastic_access -X GET "${ELASTICSEARCH_URL}/${METADATA_INDEX_NAME}/_count${COUNT_TOTAL_QUERY// /%20}" | jq -r '.count')
  STATISTICS=$(echo $STATISTICS | jq ".total = $TOTAL")
  for FIELD in $DATA_FIELDS; do
    QUERY="${COUNT_FIELD_BASE_QUERY// /%20}_exists_:${FIELD}"
    COUNT=$(curl -s --netrc-file {{ base_dir }}/conf/search_index_elastic_access -X GET "${ELASTICSEARCH_URL}/${METADATA_INDEX_NAME}/_count${QUERY}" | jq -r '.count')
    STATISTICS=$(echo $STATISTICS | jq ".${FIELD} = $COUNT")
  done

  date +"*** %Y-%m-%d %H:%M:%S persist statistics"
  curl -s --netrc-file {{ base_dir }}/conf/search_index_elastic_access --header 'Content-Type: application/json' -d "$STATISTICS" -X POST "${ELASTICSEARCH_URL}/{{ elasticsearch_metadata_index_name_prefix }}statistics_${CURRENT_DATE}/_doc"
}

createStatistics
{% if search_index_statistics_aggregation_field | default('', true) | length > 0 %}
date +"*** %Y-%m-%d %H:%M:%S determine aggregation buckets"
read -r -d '' AGGREGATION_QUERY << EOC
{
  "size": 0, 
  "aggs": {
    "statistics": {
      "terms": {
        "field": "{{ search_index_statistics_aggregation_field }}",
        "size": 1000
      }
    }
  }
}
EOC
AGGREGATION_RESPONSE=$(curl -s --netrc-file {{ base_dir }}/conf/search_index_elastic_access --header 'Content-Type: application/json' -d "$AGGREGATION_QUERY" -X POST "${ELASTICSEARCH_URL}/${METADATA_INDEX_NAME}/_search")
BUCKETS=$(echo $AGGREGATION_RESPONSE | jq -r '.aggregations.statistics.buckets | .[].key')
while IFS= read -r BUCKET; do
  createStatistics "$BUCKET"
done <<< "$BUCKETS"
{% endif %}
